"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SimpleEnvironment = void 0;
const PUPPET = __importStar(require("wechaty-puppet"));
const config_js_1 = require("../config.js");
const SimpleEnvironment = () => {
    config_js_1.log.verbose('SimpleEnvironment', '()');
    return function SimpleEnvironmentStart(mocker) {
        config_js_1.log.verbose('SimpleEnvironment', 'SimpleEnvironmentStart(%s)', mocker);
        const taskList = [];
        const loop = () => taskList.forEach(task => task());
        const timer = setInterval(loop, 5000);
        const SimpleEnvironmentStop = () => {
            config_js_1.log.verbose('SimpleEnvironment', 'SimpleEnvironmentStop()');
            clearInterval(timer);
        };
        mocker.scan('https://github.com/wechaty/wechaty-puppet-mock', PUPPET.types.ScanStatus.Waiting);
        const user = mocker.createContact();
        mocker.login(user);
        const contactList = mocker.createContacts(3);
        mocker.createRoom({
            memberIdList: [
                user.id,
                ...contactList.map(c => c.id),
            ],
        });
        taskList.push(() => {
            const contact = mocker.randomContact();
            if (contact) {
                contact.say().to();
            }
        });
        return SimpleEnvironmentStop;
    };
};
exports.SimpleEnvironment = SimpleEnvironment;
//# sourceMappingURL=environment.js.map