"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateSentence = exports.generateRoomPayload = exports.generateMessagePayloadTo = exports.generateMessagePayloadRoom = exports.generateImageFileBox = exports.generateContactPayload = void 0;
const faker_1 = __importDefault(require("faker"));
const cuid_1 = __importDefault(require("cuid"));
const PUPPET = __importStar(require("wechaty-puppet"));
const file_box_1 = require("file-box");
const generateContactPayload = () => ({
    address: faker_1.default.address.streetAddress(),
    alias: undefined,
    avatar: faker_1.default.image.avatar(),
    city: faker_1.default.address.city(),
    friend: true,
    gender: PUPPET.types.ContactGender.Male,
    id: (0, cuid_1.default)(),
    name: faker_1.default.name.findName(),
    phone: [
        faker_1.default.phone.phoneNumber(),
    ],
    province: faker_1.default.address.state(),
    signature: faker_1.default.lorem.sentence(),
    star: false,
    type: PUPPET.types.Contact.Individual,
    weixin: undefined,
});
exports.generateContactPayload = generateContactPayload;
const generateImageFileBox = () => file_box_1.FileBox.fromUrl(faker_1.default.image.avatar());
exports.generateImageFileBox = generateImageFileBox;
const generateRoomPayload = (...contactIdList) => {
    const maxNum = Math.max(500, contactIdList.length);
    const roomNum = Math.floor(maxNum * Math.random());
    const shuffledList = contactIdList.sort(() => Math.random() - 0.5);
    const memberIdList = shuffledList.slice(0, roomNum);
    const payload = {
        adminIdList: [],
        avatar: faker_1.default.image.avatar(),
        id: (0, cuid_1.default)() + '@chatroom',
        memberIdList,
        ownerId: undefined,
        topic: faker_1.default.lorem.word(),
    };
    return payload;
};
exports.generateRoomPayload = generateRoomPayload;
const generateMessagePayloadTo = () => ({
    id: (0, cuid_1.default)(),
    listenerId: (0, cuid_1.default)(),
    talkerId: (0, cuid_1.default)(),
    text: faker_1.default.lorem.sentence(),
    timestamp: Date.now(),
    type: PUPPET.types.Message.Text,
});
exports.generateMessagePayloadTo = generateMessagePayloadTo;
const generateMessagePayloadRoom = () => ({
    id: (0, cuid_1.default)(),
    mentionIdList: [],
    roomId: (0, cuid_1.default)() + '@chatroom',
    talkerId: (0, cuid_1.default)(),
    text: faker_1.default.lorem.sentence(),
    timestamp: Date.now(),
    type: PUPPET.types.Message.Text,
});
exports.generateMessagePayloadRoom = generateMessagePayloadRoom;
const generateSentence = () => faker_1.default.lorem.sentence();
exports.generateSentence = generateSentence;
//# sourceMappingURL=generator.js.map