import * as PUPPET from 'wechaty-puppet';
import type { FileBoxInterface } from 'file-box';
import type { Mocker } from '../mocker.js';
import type { RoomMock } from './room-mock.js';
import type { ContactMock } from './contact-mock.js';
declare const POOL: unique symbol;
declare class MessageMock {
    payload: PUPPET.payloads.Message;
    static get mocker(): Mocker;
    get mocker(): Mocker;
    protected static [POOL]: undefined | Map<string, MessageMock>;
    protected static get pool(): Map<string, MessageMock>;
    /**
     * @ignore
     * About the Generic: https://stackoverflow.com/q/43003970/1123955
     *
     * @static
     * @param {string} id
     * @returns {MessageMock}
     */
    static load<T extends typeof MessageMock>(this: T, id: string): T['prototype'];
    static create<T extends typeof MessageMock>(payload: PUPPET.payloads.Message): T['prototype'];
    get id(): string;
    constructor(payload: PUPPET.payloads.Message);
    talker(): ContactMock;
    room(): undefined | RoomMock;
    listener(): undefined | ContactMock;
    text(): undefined | string;
    type(): PUPPET.types.Message;
    toContact(): Promise<ContactMock>;
    toFileBox(): Promise<FileBoxInterface>;
}
declare function mockerifyMessageMock(mocker: Mocker): typeof MessageMock;
export { MessageMock, mockerifyMessageMock, };
//# sourceMappingURL=message-mock.d.ts.map