"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.packageJson = void 0;
exports.packageJson = {
    "name": "wechaty-puppet-mock",
    "version": "1.19.4",
    "description": "Puppet Mocker for Wechaty",
    "type": "module",
    "exports": {
        ".": {
            "import": "./dist/esm/src/mod.js",
            "require": "./dist/cjs/src/mod.js"
        }
    },
    "typings": "./dist/esm/src/mod.d.ts",
    "engines": {
        "node": ">= 16",
        "npm": ">=7"
    },
    "scripts": {
        "clean": "shx rm -fr dist/*",
        "dist": "npm-run-all clean build dist:commonjs",
        "build": "tsc && tsc -p tsconfig.cjs.json",
        "dist:commonjs": "jq -n \"{ type: \\\"commonjs\\\" }\" > dist/cjs/package.json",
        "start": "cross-env NODE_OPTIONS=\"--no-warnings --loader=ts-node/esm\" node examples/ding-dong-bot.ts",
        "lint": "npm-run-all lint:es lint:ts lint:md",
        "lint:md": "markdownlint README.md",
        "lint:ts": "tsc --isolatedModules --noEmit",
        "lint:es": "eslint \"src/**/*.ts\" \"tests/**/*.spec.ts\" --ignore-pattern tests/fixtures/",
        "test": "npm-run-all lint test:unit",
        "test:pack": "bash -x scripts/npm-pack-testing.sh",
        "test:unit": "cross-env NODE_OPTIONS=\"--no-warnings --loader=ts-node/esm\" tap \"src/**/*.spec.ts\" \"tests/**/*.spec.ts\""
    },
    "repository": {
        "type": "git",
        "url": "git+https://github.com/wechaty/puppet-mock.git"
    },
    "keywords": [
        "chatie",
        "wechaty",
        "chatbot",
        "bot",
        "wechat",
        "sdk",
        "puppet",
        "mock"
    ],
    "author": "Huan LI <zixia@zixia.net>",
    "license": "Apache-2.0",
    "bugs": {
        "url": "https://github.com/wechaty/puppet-mock/issues"
    },
    "homepage": "https://github.com/wechaty/puppet-mock#readme",
    "devDependencies": {
        "@chatie/eslint-config": "^1.0.4",
        "@chatie/git-scripts": "^0.6.2",
        "@chatie/semver": "^0.4.7",
        "@chatie/tsconfig": "^4.6.2",
        "@types/cuid": "^1.3.1",
        "@types/faker": "^5.5.9",
        "wechaty": "^1.18.1"
    },
    "peerDependencies": {
        "wechaty-puppet": "^1.19.4"
    },
    "dependencies": {
        "cuid": "^2.1.8",
        "faker": "^5.5.3",
        "file-box": "^1.4.15",
        "typed-emitter": "^1.5.0-from-event"
    },
    "files": [
        "bin/",
        "dist/",
        "src/"
    ],
    "publishConfig": {
        "access": "public",
        "tag": "next"
    },
    "git": {
        "scripts": {
            "pre-push": "npx git-scripts-pre-push"
        }
    }
};
//# sourceMappingURL=package-json.js.map