#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const puppet_mock_js_1 = require("./puppet-mock.js");
class PuppetMockTest extends puppet_mock_js_1.PuppetMock {
}
(0, tstest_1.test)('PuppetMock perfect restart testing', async (t) => {
    const puppet = new PuppetMockTest();
    try {
        for (let i = 0; i < 3; i++) {
            await puppet.start();
            t.ok(puppet.state.active(), 'should be turned on after start() #' + i);
            await puppet.stop();
            t.ok(puppet.state.inactive(), 'should be turned off after stop() #' + i);
        }
        t.pass('PuppetMock() perfect restart pass.');
    }
    catch (e) {
        t.fail(e);
    }
});
(0, tstest_1.test)('PuppetMock toString()', async (t) => {
    const puppet = new PuppetMockTest();
    const REGEXP = /PuppetMock/;
    t.doesNotThrow(() => puppet.toString(), 'should not throw');
    t.ok(REGEXP.test(puppet.toString()), 'should be PuppetMock');
});
//# sourceMappingURL=puppet-mock.spec.js.map